***************************************
* author Brunello Pulix
*        Cagliari (Italy)
*        brunellopulix@gmail.com
*        placed in the public domain
***************************************
*
# include "hmg.ch"
*
#DEFINE CLR_BLACK                 '  0,  0,  0'
#DEFINE CLR_WHITE                 '255,255,255'
#DEFINE CLR_DARKRED               '128,  0,  0'
#DEFINE CLR_DARKBLUE              '  0,  0,128'
#DEFINE CLR_DARKGREEN             '  0,128,  0'
#DEFINE CLR_DARKMAGENTA           '128,  0,128'
#DEFINE CLR_BROWN                 '128,128,  0'
#DEFINE CLR_DARKGRAY              '128,128,128'
#DEFINE CLR_LIGHTGRAY             '225,225,225'
#DEFINE CLR_CYAN                  '  0,128,128'
#DEFINE CLR_BLUE                  '  0,  0,255'
#DEFINE CLR_RED                   '255,  0,  0'
#DEFINE CLR_GRAY                  '192,192,192'
#DEFINE CLR_GREEN                 '  0,255,  0'
#DEFINE CLR_PINK                  '255,  0,128'
#DEFINE CLR_MAGENTA               '255,  0,255'
#DEFINE CLR_YELLOW                '255,255,  0'
#DEFINE CLR_LIGHTCYAN             '  0,255,255'
#DEFINE CLR_LIGHTYELLOW           '255,255,185'
*
#translate NTRIM( <v1> ) => ( Ltrim(str(<v1>)) )
*
Request dbfcdx
*
Static aYellow   := {255,255,0}
Static aGreen    := {128,255,0}
Static aRed      := {255,0,0}
Static aWhite    := {255,255,255}
Static aPink     := {255,0,128}
Static aEstratti := {}
Static nCurrent
*Static cWin
Static aGames    := {}
*
Procedure Main()
  Local i
  Local nFolder  := 0
  Local lBold    := .T.
  *
  Set Browsesync ON
  *
  OpenDbf()
  aEstratti := {}
  nCurrent  := 0
  *
  *
  FV3_OpenMain('TOMBOLA (Bingo) - by Brunello Pulix (Italy) - brunellopulix@gmail.com ',,{|cWin| PostInit(cWin) },{|| CloseDbf() })
  FV3_SetValue("H1"    ,'0')
  FV3_SetValue("RTF1"  ,'' )
  FV3_SetValue("FOLD1" ,'A')
  FV3_SetValue("FOLD2" ,'B')
  FV3_SetValue("FOLD3" ,'C')
  FV3_SetValue("FOLD4" ,'D')
  FV3_SetValue("FOLD5" ,'E')
  FV3_SetValue("FOLD6" ,'F')
  For i := 1 To 90
     FV3_SetValue("X"+ntrim(i),ntrim(i))
  Next
  *
  FV3_Tab_Begin(900,630)
  *
  **********************************************
  *
  FV3_Tab_BeginPage('Quadro 1')
  *
  FV3_Label('',5)
  FV3_FramedText3('FOLD'+ntrim(++nFolder),215,1,aPink,'Courier New',14,,lBold)
  FV3_Label('',25)
  FV3_FramedText3('FOLD'+ntrim(++nFolder),215,1,aPink,'Courier New',14,,lBold)
  FV3_SkipRow(25)
  *
  For i := 1 To 90
     FV3_Label(' ',5)
     FV3_FramedText3('X'+ntrim(i),35,1,aYellow,'Courier New',14)
     If i %5 == 0
        FV3_Label('   ',20)
     else
        FV3_Label(' ',5)
     Endif
     If i % 10 == 0
        *
        If i == 10
           FV3_FramedText3('H1',250,1,aGreen,'Courier New',250)
        endif
        FV3_SkipRow(25)
        If i% 30 == 0
           If i < 90
              FV3_SkipRow(15)
              FV3_Label('',5)
              FV3_FramedText3('FOLD'+ntrim(++nFolder),215,1,aPink,'Courier New',14,,lBold)
              FV3_Label('',25)
              FV3_FramedText3('FOLD'+ntrim(++nFolder),215,1,aPink,'Courier New',14,,lBold)
              FV3_SkipRow(25)
           else
              FV3_SkipRow(10)
           Endif
        endif
     Endif
  Next
  *
  FV3_Button('Nuovo Gioco'   ,100,28,{|| Nuovogioco() })
  FV3_Button('Nuovo Estratto',100,28,{|| Estratto() },.F.)
  *
  FV3_SkipRow(35)
  FV3_Browse('BROW1',800,200,{150,150,150,150,150},{'Ambo (2)','Terno (3)','Quaterna (4)','Cinquina (5)','Tombola (Bingo)'},'TEMP1',{'AMBO','TERNO','QUATERNA','CINQUINA','TOMBOLA'},Nil,nil,nil,nil,nil,.T.)
  *
  FV3_Tab_EndPage()
  *
  **********************************************
  *
  FV3_Tab_BeginPage('Statistiche')
  *
  FV3_Label('Ascendente',100)
  FV3_Label('Sequenza',480)
  FV3_SkipRow(20)
  *
  FV3_Browse('BROW2',100,475,{80},{'Estratti'},'TEMP2',{'JUMP'},Nil,nil,nil,nil,nil,.T.)
  FV3_SkipRow(-475)
  FV3_Browse('BROW3',100,475,{80},{'Estratti'},'TEMP3',{'JUMP'},Nil,nil,nil,nil,nil,.T.)
  FV3_SetCol(215)
  FV3_SkipRow(-475)
  FV3_Browse('BROW4',650,475,{25,120,120,40,120,40,120,40},{'#','Nome','Gruppo1','..','Gruppo2','..','Gruppo3','..'},'TEMP4',{'Codice','Nome','Campo1','N1','Campo2','N2','Campo3','N3'},{|| Modifica() },nil,nil,nil,nil,.T.)
  *
  FV3_Tab_EndPage()
  *
  **********************************************
  *
  FV3_Tab_BeginPage('Stampe')
  FV3_Button('Aggiorna',100,20,{|cWin| Cartelle(cWin) })
  FV3_SkipRow(20)
  FV3_Button('Svuota',100,20,{|| FV3_SetProperty('RTF1','Value','') })
  FV3_SkipRow(-20)
  FV3_RtfBox('RTF1',780,570)
  FV3_Tab_EndPage()
  *
  FV3_Tab_End()
  *
  FV3_SetFont('BROW4','Courier New',9)
  *
  FV3_Show(1)
  *
Return
*
*************************************
*
Procedure OpenDbf()
  Local i,aDbf,c2
  *
  aDbf := {}
  aadd(aDbf,{"AMBO"    ,"C",25,0})
  aadd(aDbf,{"TERNO"   ,"C",25,0})
  aadd(aDbf,{"QUATERNA","C",25,0})
  aadd(aDbf,{"CINQUINA","C",25,0})
  aadd(aDbf,{"TOMBOLA" ,"C",25,0})
  *
  hb_dbcreateTemp("TEMP1",aDbf)
  *
  dbSelectarea('Temp1')
  *
  For i := 1 To 10
     Temp1->(dbAppend())
  Next
  *
  Temp1->(dbgotop())
  *
  hb_dbcreateTemp("TEMP2",{{'JUMP','N',2,0}})
  hb_dbcreateTemp("TEMP3",{{'JUMP','N',2,0}})
  *
  If !File('Temp4.Dbf')
     dbcreate("TEMP4",{;
     {'CODICE','C', 2,0},;
     {'NOME'  ,'C',15,0},;
     {'CAMPO1','C',15,0},;
     {'CAMPO2','C',15,0},;
     {'CAMPO3','C',15,0},;
     {'N1'    ,'N', 1,0},;
     {'N2'    ,'N', 1,0},;
     {'N3'    ,'N', 1,0}},"DBFCDX")
     Use Temp4 New Exclusive Via 'DBFCDX'
     Carica()
  else
     Use Temp4 New Exclusive Via 'DBFCDX'
  Endif
  dbSelectarea('Temp4')
  Do while Temp4->(!eof())
     *
     c2 := StrTran(Temp4->Campo1,'.',' ')
     Replace Temp4->Campo1 with c2
     *
     c2 := StrTran(Temp4->Campo2,'.',' ')
     Replace Temp4->Campo2 with c2
     *
     c2 := StrTran(Temp4->Campo3,'.',' ')
     Replace Temp4->Campo3 with c2
     Replace Temp4->N1 with 0
     Replace Temp4->N2 with 0
     Replace Temp4->N3 with 0
     *
     Temp4->(dbskip())
     *
  Enddo
  Temp4->(dbgotop())
  *
Return
*
*************************************
*
Procedure CloseDbf()
  dbcloseall()
Return
*
*************************************
*
Static Procedure PostInit(cWin)
  Local i,c1
  *
  For i := 1 To 90
     c1 := ntrim(i)
     FV3_SetProperty('X'+c1,'FontBold',.T.)
  Next
  SetProperty(cWin,'H1','BackColor',aGreen  )
  SetProperty(cWin,'H1','Height'   ,263     )
  SetProperty(cWin,'H1','FontName' ,'Arial' )
  SetProperty(cWin,'H1','FontSize' ,170     )
  SetProperty(cWin,'H1','FontBold' ,.T.     )
  SetProperty(cWin,'H1','Alignment','Center')
  *
  DEFINE CONTROL CONTEXTMENU BROW4 OF &(cWin)
  *
  ITEM "Modifica"            ACTION {|| Modifica() }
  SEPARATOR
  ITEM "Filtro"              ACTION {|| Filtro() }
  End Menu
  *
Return
*
*************************************
*
Static Procedure Nuovogioco()
  Local i
  Local c1
  Local c2
  *
  FV3_SetProperty('H1','Value','0')
  For i := 1 To 90
     c1 := ntrim(i)
     FV3_SetProperty('X'+c1,'BackColor',aYellow)
  Next
  *
  aEstratti := FillNum(90,90)
  nCurrent  := 0
  *
  c2 := FV3_GetButtonName('Nuovo Gioco')
  FV3_SetProperty(c2,'Enabled',.F.)
  *
  c2 := FV3_GetButtonName('Nuovo Estratto')
  FV3_SetProperty(c2,'Enabled',.T.)
  *
  dbSelectarea('Temp1')
  Temp1->(dbgotop())
  For i := 1 To 10
     Replace Temp1->Ambo     with space(25)
     Replace Temp1->Terno    with space(25)
     Replace Temp1->Quaterna with space(25)
     Replace Temp1->Cinquina with space(25)
     Replace Temp1->Tombola  with space(25)
     Temp1->(dbskip())
  Next
  Temp1->(dbgotop())
  FV3_SetProperty('BROW1','Value',Temp1->(Recno()))
  *
  dbSelectarea('Temp2')
  dbclosearea('Temp2')
  *
  dbSelectarea('Temp3')
  dbclosearea('Temp3')
  hb_dbcreateTemp("TEMP2",{{'JUMP','N',2,0}})
  Index On Temp2->Jump TO TEMP2
  dbSelectarea('Temp2')
  Temp2->(dbgotop())
  FV3_SetProperty('BROW2','Value',Temp2->(Recno()))
  *
  hb_dbcreateTemp("TEMP3",{{'JUMP','N',2,0}})
  Temp3->(dbgotop())
  FV3_SetProperty('BROW3','Value',Temp3->(Recno()))
  *
  dbSelectarea('Temp4')
  Do while Temp4->(!eof())
     *
     c2 := StrTran(Temp4->Campo1,'.',' ')
     Replace Temp4->Campo1 with c2
     *
     c2 := StrTran(Temp4->Campo2,'.',' ')
     Replace Temp4->Campo2 with c2
     *
     c2 := StrTran(Temp4->Campo3,'.',' ')
     Replace Temp4->Campo3 with c2
     Replace Temp4->N1 with 0
     Replace Temp4->N2 with 0
     Replace Temp4->N3 with 0
     *
     Temp4->(dbskip())
     *
  Enddo
  Temp4->(dbgotop())
  FV3_SetProperty('BROW4','Value',Temp4->(Recno()))
  FV3_DoMethod('BROW4','Refresh')
  dbSelectarea('Temp1')
  aGames   := {2,3,4,5,15}
  *
Return
*
*************************************
*
Function FillNum(nRand,nMax)
  Local aTemp := {}, cString := '', number := 0
  *
  number := hb_RandomInt(nRand)
  if number > 0
     cString += str(number,2) + '|'
     AADD(aTemp,str(number,2))
  endif
  do while Len(aTemp) != nMax
     number := hb_RandomInt(nRand)
     if number > 0 .and. ( ! str(number,2) $ cString)
        cString += str(number,2) + '|'
        AADD(aTemp,str(number,2))
     endif
  enddo
Return aTemp
*
*************************************
*
Procedure Estratto()
  Local c1,c2,c3,c4,a1,a2,i,bLock1,n
  Local lTombola := .F.
  *
  c1 := ltrim(aEstratti[++nCurrent])
  FV3_SetProperty('H1','Value',c1)
  FV3_SetProperty('X'+c1,'BackColor',aRed)
  *
  *
  Temp2->(Dbappend())
  Replace Temp2->Jump with val(c1)
  FV3_SetProperty('BROW2','Value',Temp2->(Recno()))
  *
  Temp3->(Dbappend())
  Replace Temp3->Jump with val(c1)
  FV3_SetProperty('BROW3','Value',Temp3->(Recno()))
  *
  DbSelectarea('Temp4')
  Temp4->(dbgotop())
  Do while Temp4->(!Eof())
     *
     If !Empty(Temp4->Nome)
        If val(c1) < 10
           c2 := Left('0'+c1,2)
        else
           c2 := c1
        endif
        *
        If c2 $ Temp4->Campo1
           n := Temp4->N1
           Replace Temp4->N1 with n+1
           c3 := StrTran(Temp4->Campo1,c2+' ',c2+'.')
           Replace Temp4->Campo1 with c3
        elseif c2 $ Temp4->Campo2
           n := Temp4->N2
           Replace Temp4->N2 with n+1
           c3 := StrTran(Temp4->Campo2,c2+' ',c2+'.')
           Replace Temp4->Campo2 with c3
        elseif c2 $ Temp4->Campo3
           n := Temp4->N3
           Replace Temp4->N3 with n+1
           c3 := StrTran(Temp4->Campo3,c2+' ',c2+'.')
           Replace Temp4->Campo3 with c3
        Endif
     Endif
     DbSelectarea('Temp4')
     Temp4->(dbskip())
  Enddo
  If Len(aGames) == 1
     bLock1 := {|| Temp4->N1+Temp4->N2+Temp4->N3 == 15}
  else
     bLock1 := {|| Temp4->N1 == aGames[1] .or. Temp4->N2 == aGames[1] .or. Temp4->N3 == aGames[1]}
  Endif
  a1 := {}
  Temp4->(dbgotop())
  Do while Temp4->(!Eof())
     If eval(bLock1)
        aadd(a1,[Cartella ]+Temp4->Codice+'-'+Temp4->Nome)
     Endif
     Temp4->(dbskip())
  Enddo
  *
  c4 := ''
  If !Empty(a1)
     DbSelectarea('Temp1')
     For i := 1 To Len(a1)
        If aGames[1] == 2
           Locate For empty(Temp1->Ambo)
           Replace Temp1->Ambo with a1[i]
        elseif aGames[1] == 3
           Locate For empty(Temp1->Terno)
           Replace Temp1->Terno with a1[i]
        elseif aGames[1] == 4
           Locate For empty(Temp1->Quaterna)
           Replace Temp1->Quaterna with a1[i]
        elseif aGames[1] == 5
           Locate For empty(Temp1->Cinquina)
           Replace Temp1->Cinquina with a1[i]
        elseif aGames[1] == 15
           Locate For empty(Temp1->Tombola)
           Replace Temp1->Tombola with a1[i]
           lTombola := .T.
           c4 := a1[i]+'-Tombola'
        Endif
     Next
     FV3_SetProperty('BROW1','Value',Temp1->(Recno()))
     FV3_DoMethod('BROW1','Refresh')
     hb_ADel(aGames,1)
  Endif
  *
  DbSelectarea('Temp4')
  Temp4->(dbgotop())
  FV3_SetProperty('BROW4','Value',Temp4->(Recno()))
  FV3_DoMethod('BROW4','Refresh')
  Do Events
  *
  If nCurrent == 90 .or. lTombola
     c2 := FV3_GetButtonName('Nuovo Estratto')
     FV3_SetProperty(c2,'Enabled',.F.)
     c2 := FV3_GetButtonName('Nuovo Gioco')
     FV3_SetProperty(c2,'Enabled',.T.)
     msginfo(c4)
     *
  Endif
  *
Return
*
*************************************
*
Function ReadN()
  Local array := {}
  AADD(array,' A|               |01 02 03 04 05 |11 12 13 14 15 |21 22 23 24 25 ')
  AADD(array,' B|               |06 07 08 09 10 |16 17 18 19 20 |26 27 28 29 30 ')
  AADD(array,' C|               |31 32 33 34 35 |41 42 43 44 45 |51 52 53 54 55 ')
  AADD(array,' D|               |36 37 38 39 40 |46 47 48 49 50 |56 57 58 59 60 ')
  AADD(array,' E|               |61 62 63 64 65 |71 72 73 74 75 |81 82 83 84 85 ')
  AADD(array,' F|               |66 67 68 69 70 |76 77 78 79 80 |86 87 88 89 90 ')
  AADD(array,' 1|               |01 23 44 61 80 |16 36 59 68 89 |28 49 58 71 84 ')
  AADD(array,' 2|               |02 24 39 56 63 |13 31 48 67 70 |07 19 46 51 87 ')
  AADD(array,' 3|               |03 20 38 79 86 |10 33 41 65 77 |18 29 45 50 83 ')
  AADD(array,' 4|               |04 17 32 66 82 |14 27 40 53 74 |08 37 60 78 85 ')
  AADD(array,' 5|               |05 21 47 73 81 |11 25 35 52 75 |15 30 55 62 72 ')
  AADD(array,' 6|               |06 26 43 57 76 |12 34 54 64 88 |09 22 42 69 90 ')
  AADD(array,' 7|               |07 31 40 69 79 |04 23 37 53 74 |13 25 47 58 87 ')
  AADD(array,' 8|               |08 22 67 72 83 |18 33 49 61 73 |03 24 35 50 85 ')
  AADD(array,' 9|               |09 20 36 70 84 |16 46 56 71 86 |02 27 38 51 66 ')
  AADD(array,'10|               |10 29 52 68 82 |05 32 41 65 80 |19 28 44 78 81 ')
  AADD(array,'11|               |11 21 45 63 88 |14 30 48 54 77 |01 17 57 62 90 ')
  AADD(array,'12|               |12 39 43 59 75 |06 42 55 60 89 |15 26 34 64 76 ')
  AADD(array,'13|               |13 25 45 62 79 |07 36 47 69 89 |10 38 57 75 84 ')
  AADD(array,'14|               |14 26 49 65 78 |05 33 48 67 81 |01 28 37 59 77 ')
  AADD(array,'15|               |15 21 46 53 80 |09 32 58 61 83 |02 11 41 50 74 ')
  AADD(array,'16|               |16 35 44 60 88 |03 22 56 66 87 |08 29 42 54 70 ')
  AADD(array,'17|               |17 20 43 64 90 |09 19 34 73 85 |04 24 31 55 71 ')
  AADD(array,'18|               |18 23 52 72 86 |12 30 40 68 76 |27 39 51 63 82 ')
  AADD(array,'19|               |19 31 54 63 82 |03 10 45 67 74 |28 40 55 75 90 ')
  AADD(array,'20|               |20 33 56 68 85 |04 12 38 65 71 |09 26 47 59 88 ')
  AADD(array,'21|               |21 37 50 73 84 |05 18 34 42 62 |11 30 43 61 89 ')
  AADD(array,'22|               |22 36 52 76 80 |07 13 41 60 77 |02 17 27 46 81 ')
  AADD(array,'23|               |23 35 51 64 83 |08 15 32 57 72 |16 29 48 78 87 ')
  AADD(array,'24|               |24 44 53 66 86 |06 14 39 58 79 |01 25 49 69 70 ')
  AADD(array,'25|               |12 33 41 80 74 |03 21 54 77 80 |17 36 48 65 89 ')
  AADD(array,'26|               |01 24 45 52 83 |18 31 49 66 70 |09 26 58 72 87 ')
  AADD(array,'27|               |04 30 51 63 82 |11 23 42 68 75 |07 28 39 56 90 ')
  AADD(array,'28|               |14 20 57 62 81 |05 16 32 43 78 |25 37 59 64 86 ')
  AADD(array,'29|               |06 13 34 40 71 |22 38 53 69 85 |08 19 47 55 76 ')
  AADD(array,'30|               |10 27 44 61 73 |02 35 50 79 84 |15 29 46 67 88 ')
  AADD(array,'31|               |12 20 45 63 71 |08 37 51 79 82 |17 24 48 66 90 ')
  AADD(array,'32|               |01 23 40 52 74 |10 38 57 61 85 |04 27 49 76 88 ')
  AADD(array,'33|               |15 33 41 60 86 |03 28 54 72 89 |19 35 46 68 77 ')
  AADD(array,'34|               |05 22 50 64 81 |16 31 42 69 78 |07 29 34 55 83 ')
  AADD(array,'35|               |21 36 53 62 80 |06 13 39 44 75 |18 25 59 67 84 ')
  AADD(array,'36|               |02 11 43 56 70 |26 30 58 65 87 |09 14 32 47 73 ')
  AADD(array,'37|               |01 22 61 72 83 |17 33 49 67 73 |08 18 35 50 85 ')
  AADD(array,'38|               |02 23 39 51 79 |10 29 40 70 87 |20 34 43 66 89 ')
  AADD(array,'39|               |11 21 45 62 88 |14 30 48 54 77 |03 24 57 63 90 ')
  AADD(array,'40|               |04 25 44 59 71 |05 31 47 60 80 |13 27 38 52 74 ')
  AADD(array,'41|               |12 36 53 68 81 |06 32 55 75 86 |16 26 41 64 84 ')
  AADD(array,'42|               |07 28 46 58 76 |09 15 42 65 82 |19 37 56 69 78 ')
  AADD(array,'43|               |01 23 36 58 74 |17 38 47 69 80 |10 26 40 61 86 ')
  AADD(array,'44|               |02 29 41 62 79 |19 30 48 66 87 |03 24 37 55 70 ')
  AADD(array,'45|               |04 22 42 59 82 |11 31 53 71 88 |18 25 49 60 75 ')
  AADD(array,'46|               |05 21 43 68 83 |12 39 54 72 89 |09 32 52 63 76 ')
  AADD(array,'47|               |13 34 50 73 84 |06 20 44 64 81 |15 27 46 57 77 ')
  AADD(array,'48|               |07 14 28 56 78 |16 33 45 65 85 |08 35 51 67 90 ')
Return array
*
*************************************
*
Procedure Carica()
  Local aRay := ReadN()
  Local i,a1
  *
  For i := 1 To Len(aRay)
     a1 := hb_ATokens(aRay[i],'|')
     Temp4->(dbappend())
     Replace Temp4->Codice with a1[1]
     Replace Temp4->Nome   with a1[2]
     Replace Temp4->Campo1 with a1[3]
     Replace Temp4->Campo2 with a1[4]
     Replace Temp4->Campo3 with a1[5]
  Next
  Temp4->(dbgotop())
  *
Return
*
*************************************
*
Procedure Modifica()
  Local c1,c2,nRec
  *
  nRec := Temp4->(Recno())
  c1 := Left(Temp4->Nome,15)
  c2 := MyInputBox('Nome '+Temp4->Codice,'Modifica',c1)
  *
  If !Empty(c2)
     Temp4->(dbgoto(nRec))
     Replace Temp4->Nome with Left(c2,15)
     FV3_SetProperty('BROW4','Value',Temp4->(Recno()))
     FV3_Refresh('BROW4')
  Endif
  *
Return
*
*************************************
*
Procedure Filtro()
  *
  If Empty(Temp4->(Dbfilter()))
     Set Filter To !Empty(Temp4->Nome)
  else
     Set Filter To
  Endif
  Temp4->(dbgotop())
  FV3_SetProperty('BROW4','Value',Temp4->(Recno()))
  *
Return
*
*************************************
*
Procedure Cartelle(cWin)
  Local aTable,a1,n,aTemp,c1,x,aFlags:={}
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{10,10,10,10,10,10,10,10,10,10})
  AAdd(aTable,{60,40})
  *
  RTF_OPEN('Cartelle.Rtf',aTable,'P')
  *
  x := 0
  dbselectarea('Temp4')
  Temp4->(dbgoto(7))
  *
  Do while Temp4->(!Eof())
     *
     If Empty(Temp4->Nome)
        Temp4->(dbskip())
        Loop
     Endif
     *
     ++x
     *
     c1 := RtfStyle('Cartella N',"",'0',"70","")
     c1 += RtfStyle('o',"uX",'0',"70","")
     c1 += ' '+RtfStyle(Trim(Temp4->Codice),"b",'0',"80","")
     *
     RTF_WriteRow(3,{;
     MakeCell(c1,"40","l","LTR","",0,"","",""),;
     MakeCell(Trim(Temp4->Nome),"30","l","BTR","",0,"","","")})
     *
     a1 := XY(Temp4->Campo1,@aFlags)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","l","LT" ,"" ,0,"","",aFlags[1]),;
     MakeCell(a1[2],"70","l","LT" ,"" ,0,"","",aFlags[2]),;
     MakeCell(a1[3],"70","l","LT" ,"" ,0,"","",aFlags[3]),;
     MakeCell(a1[4],"70","l","LT" ,"" ,0,"","",aFlags[4]),;
     MakeCell(a1[5],"70","l","LT" ,"" ,0,"","",aFlags[5]),;
     MakeCell(a1[6],"70","l","LT" ,"" ,0,"","",aFlags[6]),;
     MakeCell(a1[7],"70","l","LT" ,"" ,0,"","",aFlags[7]),;
     MakeCell(a1[8],"70","l","LT" ,"" ,0,"","",aFlags[8]),;
     MakeCell(a1[9],"70","l","LTR","" ,0,"","",aFlags[9]),;
     MakeCell(''   ,"70","l","BRT"  ,"" ,0,"","","") })
     *
     a1 := XY(Temp4->Campo2,@aFlags)
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","l","LT" ,"" ,0,"","",aFlags[1]),;
     MakeCell(a1[2],"70","l","LT" ,"" ,0,"","",aFlags[2]),;
     MakeCell(a1[3],"70","l","LT" ,"" ,0,"","",aFlags[3]),;
     MakeCell(a1[4],"70","l","LT" ,"" ,0,"","",aFlags[4]),;
     MakeCell(a1[5],"70","l","LT" ,"" ,0,"","",aFlags[5]),;
     MakeCell(a1[6],"70","l","LT" ,"" ,0,"","",aFlags[6]),;
     MakeCell(a1[7],"70","l","LT" ,"" ,0,"","",aFlags[7]),;
     MakeCell(a1[8],"70","l","LT" ,"" ,0,"","",aFlags[8]),;
     MakeCell(a1[9],"70","l","LTR","" ,0,"","",aFlags[9]),;
     MakeCell(''   ,"70","l","BR"   ,"" ,0,"","","")})
     *
     a1 := XY(Temp4->Campo3,@aFlags)
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","l","BLT" ,"" ,0,"","",aFlags[1]),;
     MakeCell(a1[2],"70","l","BLT" ,"" ,0,"","",aFlags[2]),;
     MakeCell(a1[3],"70","l","BLT" ,"" ,0,"","",aFlags[3]),;
     MakeCell(a1[4],"70","l","BLT" ,"" ,0,"","",aFlags[4]),;
     MakeCell(a1[5],"70","l","BLT" ,"" ,0,"","",aFlags[5]),;
     MakeCell(a1[6],"70","l","BLT" ,"" ,0,"","",aFlags[6]),;
     MakeCell(a1[7],"70","l","BLT" ,"" ,0,"","",aFlags[7]),;
     MakeCell(a1[8],"70","l","BLT" ,"" ,0,"","",aFlags[8]),;
     MakeCell(a1[9],"70","l","BLTR","" ,0,"","",aFlags[9]),;
     MakeCell(''   ,"70","l","BR"    ,"" ,0,"","","")})
     *
     RTF_EMPTYROW()
     RTF_EMPTYROW()
     RTF_EMPTYROW()
     RTF_EMPTYROW()
     RTF_EMPTYROW()
     *
     If x == 3
        *RTF_NEWSECTION()  // Word
        RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        x := 0
     Endif
     Temp4->(dbskip())
  Enddo
  Temp4->(dbgotop())
  *
  RTF_CLOSE()
  *
  *RUN_WORD('Cartelle.Rtf')
  #Ifdef ___FV3_HMG___
     sleep(1000)
     FV3_DoMethod('RTF1','RTFLoadFile','\'+CurDir()+'\Cartelle.Rtf')
     FV3_DoMethod('RTF1','Refresh')
  #else
     RUN_WORD('Cartelle.Rtf')
  #endif
  *
Return
*
*************************************
*
Procedure Run_Word(cRtf)
  *
  execute file cRtf
  *
Return
*
*************************************
*
Function XY(c1,aFlags)
  Local a1,a2,n1,i
  *
  a2 := array(9)
  afill(a2,' ')
  *
  a1    := array(5)
  a1[1] := Substr(c1,1,3)
  a1[2] := Substr(c1,4,3)
  a1[3] := Substr(c1,7,3)
  a1[4] := Substr(c1,10,3)
  a1[5] := Substr(c1,13,3)
  *
  *avviso(a1[1])
  aFlags := array(9)
  afill(aFlags,'')
  *
  For i := 1 To Len(a1)
     n1 := val(a1[i])
     If n1 < 10
        aFlags[1] := If(Right(a1[i],1) == '.','2','')
        a2[1]     := Left(a1[i],2)
     elseIf n1 < 20
        aFlags[2] := If(Right(a1[i],1) == '.','2','')
        a2[2]     := Left(a1[i],2)
     elseIf n1 < 30
        aFlags[3] := If(Right(a1[i],1) == '.','2','')
        a2[3]     := Left(a1[i],2)
     elseIf n1 < 40
        aFlags[4] := If(Right(a1[i],1) == '.','2','')
        a2[4]     := Left(a1[i],2)
     elseIf n1 < 50
        a2[5]     := a1[i]
        aFlags[5] := If(Right(a1[i],1) == '.','2','')
        a2[5]     := Left(a1[i],2)
     elseIf n1 < 60
        aFlags[6] := If(Right(a1[i],1) == '.','2','')
        a2[6]     := Left(a1[i],2)
     elseIf n1 < 70
        aFlags[7] := If(Right(a1[i],1) == '.','2','')
        a2[7]     := Left(a1[i],2)
     elseIf n1 < 80
        aFlags[8] := If(Right(a1[i],1) == '.','2','')
        a2[8]     := Left(a1[i],2)
     elseIf n1 > 79
        aFlags[9] := If(Right(a1[i],1) == '.','2','')
        a2[9]     := Left(a1[i],2)
     Endif
  Next
  *
Return a2
*
*************************************
*
Procedure MyInputBox(cDesc,cCaption,cText,cPict)
  Local cRet := ''
  *
  hb_default(@cPict,'')
  *
  FV3_OpenModal(cCaption)
  FV3_SetValue('STRING',cText)
  *
  FV3_Label(cDesc,250)
  FV3_SkipRow(25)
  FV3_TextBox('STRING' ,250,cPict)
  *
  FV3_Show(2)
  *
  If FV3_Result()
     cRet := Trim(FV3_GetValue('STRING'))
  endif
  *
Return cRet
*
